    .include "D:\Program Files\Atmel\AVR Studio\Appnotes\m8def.inc"

;    ,  1.1- 2006.
.def	tmp  	= 	r16	
.def	coc  	= 	r17	
.def	vih  	= 	r18
.def	tempo	= 	r19
.def	pir	=	r22
.def	pur	=	r23
.def	par	=	r20
.def	Y	=	r29
.def	X	=	r21
.def	Wa	=	r26
.def	adr	=	r0
.def	prg1	= 	r24
.def	prg2	=	r25
.def	tmp2	=	r27
.def	per	=	r28


.cseg
;  ,  
.org 0
	nop		;rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop		;rjmp  TIME_OVF0   
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	
;     
.org 20
;  , C, D
	clr	tmp
	clr	coc
	ldi	coc, $3F	; B,-		
	out	DDRB, coc
	out	PORTB, tmp	;  
	ldi	coc, $3F	; -
	out	DDRC, coc
	out	PORTC, tmp	;  C
	ldi	coc, $FF	; D-
	out	DDRD, coc
	out	PORTD, tmp	;  D
	ldi	tmp, low(RAMEND)
	out	SPL, tmp
;  
	cli
	clr	pir
	clr	pur
	clr	prg1
	clr	prg2
	clr	adr
	clr	per		
			
;   

nStart:	nop		; 
	nop
	ldi	tempo,	$28
	nop
	rjmp	zader
	nop
ss:	nop
	rjmp	opros
	nop
ee:	nop
	rjmp	nStart
	
;   
;  
zader:	nop
	wdr
	clr	Wa
	nop
dm:	nop
	clr	X
	clr	Y
dv:	nop
	wdr
	mov	Y,  tempo
dx:	dec	Y
	brpl	dx
	cln
	cls
	inc	X
	cpi	x, $0E
	brlo	dv
	inc	Wa
	cpi	wa, $F0
	brlo	dm	
	nop
	rjmp	ss


;   
opros:	nop
	nop
progo:	nop
;  
	cpi	pir, $0C
	nop
	breq	prn2
	ldi	ZH,	high(2*prog1)
	ldi	ZL,	Low(2*prog1)
	Add	ZL,	pir
	LPM
	mov	prg1, adr
;    
	out	PORTC, prg1
	nop
	ldi	ZH,	high(2*prog2)
	ldi	ZL,	Low(2*prog2)
	Add	ZL,	pir
	LPM
	mov	prg1, adr
;    
	out	PORTD, prg1
	nop
	ldi	ZH,	high(2*prog3)
	ldi	ZL,	Low(2*prog3)
	Add	ZL,	pir
	LPM
	mov	prg1, adr
;  
	out	PORTB, prg1
	nop
	inc	pir
	nop
	rjmp	got

prn2:	nop
;  
	cpi	pur, $0C
	nop
	breq	prn3
	ldi	ZH,	high(2*prog4)
	ldi	ZL,	Low(2*prog4)
	Add	ZL,	pur
	LPM
	mov	prg2, adr
;    
	out	PORTC, prg2
	nop
	ldi	ZH,	high(2*prog5)
	ldi	ZL,	Low(2*prog5)
	Add	ZL,	pur
	LPM
	mov	prg1, adr
;    
	out	PORTD, prg1
	nop
	ldi	ZH,	high(2*prog6)
	ldi	ZL,	Low(2*prog6)
	Add	ZL,	pur
	LPM
	mov	prg1, adr
;  
	out	PORTB, prg1
	nop
	inc	pur
	nop
	rjmp	got

prn3:	nop
;  
	cpi	par, $0C
	nop
	breq	prn4
	ldi	ZH,	high(2*prog7)
	ldi	ZL,	Low(2*prog7)
	Add	ZL,	par
	LPM
	mov	prg2, adr
;    
	out	PORTC, prg2
	nop
	ldi	ZH,	high(2*prog8)
	ldi	ZL,	Low(2*prog8)
	Add	ZL,	par
	LPM
	mov	prg1, adr
;    
	out	PORTD, prg1
	nop
	ldi	ZH,	high(2*prog9)
	ldi	ZL,	Low(2*prog9)
	Add	ZL,	par
	LPM
	mov	prg1, adr
;  
	out	PORTB, prg1
	nop
	inc	par
	nop
	rjmp	got
prn4:	nop
;  
	cpi	per, $0C
	nop
	breq	nasv
	ldi	ZH,	high(2*prog10)
	ldi	ZL,	Low(2*prog10)
	Add	ZL,	per
	LPM
	mov	prg2, adr
;    
	out	PORTC, prg2
	nop
	ldi	ZH,	high(2*prog11)
	ldi	ZL,	Low(2*prog11)
	Add	ZL,	per
	LPM
	mov	prg1, adr
;    
	out	PORTD, prg1
	nop
	ldi	ZH,	high(2*prog12)
	ldi	ZL,	Low(2*prog12)
	Add	ZL,	per
	LPM
	mov	prg1, adr
;  
	out	PORTB, prg1
	nop
	inc	per
	nop
	rjmp	got

nasv:	nop
	clr	pir
	clr	pur
	clr	par
	clr	adr
	clr	per
	rjmp	progo
	nop
got:	nop
	nop
	rjmp	ee


.org $100
prog1:
.DB  $00, $00, $00, $00, $00, $00, $11, $03
.DB  $05, $09, $21, $01

prog2:
.DB  $06, $08, $10, $20, $40, $80, $00, $00
.DB  $00, $00, $00, $01

prog3:
.DB  $01, $00, $01, $00, $01, $00, $01, $11
.DB  $00, $00, $00, $00 

prog4:
.DB  $00, $00, $20, $08, $04, $02, $11, $01
.DB  $01, $01, $01, $01

prog5:
.DB  $06, $01, $00, $00, $00, $00, $00, $80
.DB  $40, $20, $10, $08

prog6:
.DB  $00, $00, $00, $00, $00, $00, $01, $01
.DB  $01, $01, $01, $01

prog7:
.DB  $01, $01, $21, $29, $2D, $2E, $3F, $3F
.DB  $2E, $1F, $17, $01

prog8:
.DB  $06, $0F, $1F, $3F, $7F, $FF, $FF, $F9
.DB  $F0, $E0, $C0, $00

prog9:
.DB  $02, $00, $02, $00, $02, $00, $02, $11
.DB  $00, $00, $00, $00

prog10:
.DB  $00, $28, $0C, $06, $12, $10, $00, $00
.DB  $00, $00, $00, $10

prog11:
.DB  $06, $00, $00, $00, $00, $80, $C0, $60
.DB  $30, $12, $0C, $04

prog12:
.DB  $02, $00, $02, $00, $02, $00, $02, $03
.DB  $00, $00, $00, $00

.EXIT

 