    .include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn15def.inc"
.def	tmp  	= 	r16	
.def	coc  	= 	r17	
.def	vih  	= 	r18
.def	tempo	= 	r19
.def	pir	=	r22
.def	pur	=	r23
.def	par	=	r20
.def	Y	=	r29
.def	X	=	r21
.def	W	=	r26
.def	prg1	= 	r24
.def	prg2	=	r25
.def	adr2	= 	r27
.def	aur	= 	r15
.def	adr	= 	r0

;  
.cseg
.org 0
; 
	rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop		;rjmp  LOW_LEVEL
	nop		;rjmp  TIME_1
	rjmp  TIME_0 	;  
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	
;    
.org 20
;  
RESET:	clr	tmp		
	out	DDRB, tmp
	out	PORTB, tmp	;  
	wdr
;  time0
	clr	coc
	ldi	coc, 1<<TOIE0
	out	TIMSK, coc
	ldi	coc, 1<<TOV0
	out	TIFR, coc
	ldi	coc, 3	; /64
	out	TCCR0, coc
	ldi	coc, $ff-45
	out	TCNT0, coc
	
	
;     
;  
nStart:	nop			; 
	clr	coc
	ldi	coc, $0F	;PB0,PB1,2,3-		
	out	DDRB, coc
	nop
	ldi	par, $0F
	clr	tmp
	clr	pir
	clr	pur
	clr	prg1
	clr	prg2
	sei
Dup:	clr	vih
	rcall	zader
	clz
; 
	inc	tempo
	in	vih, PORTB
	andi	vih, $10
	cpi	vih, $10	
	brne Dup
	inc	tmp
	cpi	tmp, $03   ; 3  
	brbs	1, prod
;  ,   5  
	cpi	tempo, $05 
	brbc	1, dup
	clr	tmp
	clr	tempo
	rjmp	dup
	nop
;   

prod:	nop
	clz
	clr	tempo
	clr	tmp
	inc	pir
	nop
;   9  
	cpi	pir, $09   ; 9 
	brbs	1, razr
	rjmp	Dup
razr:	nop
	clz
	inc	pur
;   99  
	cpi	pur, $09   ; 9
	brbs	1, sbr
	rjmp	Dup
sbr:	nop
	clz
	clr	pir
	clr	pur
	rjmp	Dup
	
; .
;   
zader:	nop
	wdr
	clr	X
	clr	Y
	ldi	X,  $0A
dv:	nop
	wdr
	mov	Y,  par
dx:	dec	Y
	brne	dx
	dec	X
	brne	dv
	ret

;   
;     
TIME_0:	wdr	
	mov	r9, tempo
	mov	r1, tmp
	mov	r2, pir
	mov	r3, pur
	mov	r4, adr
	mov	r5,	x
	mov	r6, y
	mov	r8, par
	mov	par, r2	; 
	clr	prg2
	ldi	adr2, $37 ; 
	rcall	opros
	rcall	zader
	clr	prg2
	mov	par, r3	; 
	ldi	adr2, $3F ; 
	rcall	opros
	rcall	zader
	ldi	adr2, $37
	rcall sbros
	ldi	adr2, $3F
	rcall sbros
	ldi	coc, $ff-45
	out	TCNT0, coc
	mov	tempo, r9
	mov	tmp, r1
	mov	pir, r2
	mov	pur, r3
	mov	adr, r4
	mov	x, r5
	mov	y, r6
	mov	par, r8
	sei
	reti
;  
opros:	cli		;  
	nop
	clz
	mov 	r7, par	 ; par
	ldi	prg2, $00
	ldi	r31, high(2*cod)
	ldi	r30, Low(2*cod)
	mov	W, par
	cpi	W, 0	;  0
	brbs 1, hod	;  0 
ist:	nop
	brbs 1, hod	;   
	ldi	tmp, $0A
	add	r30, tmp	; 
	dec	par	;par   
	rjmp	ist

hod:	clz
	mov	r12, r30	
xod:	mov	r30, r12
	cpi	prg2, $09 ;   
	breq	nasv	;9  
	add	r30, prg2	;  
	LPM	;   R0    Z
	and	adr, adr2 ;adr2- 
	clr	aur	; 
	out	PORTB, aur
	nop
	nop
	out	PORTB, adr
	nop
	nop
	nop
	nop
	nop
	out	PORTB, aur
	nop
	nop
	inc	prg2	;  
	rjmp	xod
nasv:	mov	par, r7	; par	
	clr	pir
	clr	adr
	ret
;  
sbros:	nop
	ldi	prg1, $3B
	clr	aur
	out PORTB, aur
	and	prg1, adr2
	nop
	out	PORTB, prg1
	nop
	nop
	nop
	nop
	nop
	out PORTB, aur
	ret
;  
.org $100
cod:
.DB  $3B, $3E, $3E, $3E, $3E, $3E, $3E, $3A
.DB  $3A

cod1:
.DB  $3B, $3A, $3E, $3E, $3A, $3A, $3A, $3A
.DB  $3A

cod2:
.DB  $3B, $3E, $3E, $3A, $3E, $3E, $3A, $3E
.DB  $3A

cod3:
.DB  $3B, $3E, $3E, $3E, $3E, $3A, $3A, $3E
.DB  $3A

cod4:
.DB  $3B, $3A, $3E, $3E, $3A, $3A, $3E, $3E
.DB  $3A

cod5:
.DB  $3B, $3E, $3A, $3E, $3E, $3A, $3E, $3E
.DB  $3A

cod6:
.DB  $3B, $3E, $3A, $3E, $3E, $3E, $3E, $3E
.DB  $3A

cod7:
.DB  $3B, $3E, $3E, $3E, $3A, $3A, $3A, $3A
.DB  $3A

cod8:
.DB  $3B, $3E, $3E, $3E, $3E, $3E, $3E, $3E
.DB  $3A

cod9:
.DB  $3B, $3E, $3E, $3E, $3E, $3A, $3E, $3E
.DB  $3A
.EXIT

 