    .include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn12def.inc"
.def	tmp  	= 	r16	
.def	coc  	= 	r17	
.def	vih  	= 	r18
.def	tempo	= 	r19
.def	pir	=	r22
.def	pur	=	r23
.def	par	=	r20
.def	Y	=	r29
.def	X	=	r21
.def	W	=	r26
.def	prg1	= 	r24
.def	prg2	=	r25
.def	adr2	= 	r27
.def	aur	= 	r15
.def	adr	= 	r8

;  
.cseg
.org 0
; 
	rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop
	nop
	rjmp  TIME_0 	;  
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	
;    
.org 20
;  
RESET:	clr	tmp		
	out	DDRB, tmp
	out	PORTB, tmp	;  
	wdr
;  time0
	clr	coc
	ldi	coc, 1<<TOIE0
	out	TIMSK, coc
	ldi	coc, 1<<TOV0
	out	TIFR, coc
	ldi	coc, 3	; /64
	out	TCCR0, coc
	ldi	coc, $ff-45
	out	TCNT0, coc
	
	
;     
;  
nStart:	nop			; 
	clr	coc
	ldi	coc, $0F	;PB0,PB1,2,3-		
	out	DDRB, coc
	nop
	ldi	par, $0F
	clr	tmp
	clr	pir
	clr	pur
	clr	prg1
	clr	prg2
	sei
Dup:	clr	vih
	rcall	zader
	clz
; 
	inc	tempo
	in	vih, PORTB
	andi	vih, $10
	cpi	vih, $10	
	brne Dup
	inc	tmp
	cpi	tmp, $03   ; 3  
	brbs	1, prod
;  ,   5  
	cpi	tempo, $05 
	brbc	1, dup
	clr	tmp
	clr	tempo
	rjmp	dup
	nop
;   

prod:	nop
	clz
	clr	tempo
	clr	tmp
	inc	pir
	nop
;   9  
	cpi	pir, $09   ; 9 
	brbs	1, razr
	rjmp	Dup
razr:	nop
	clz
	inc	pur
;   99  
	cpi	pur, $09   ; 9
	brbs	1, sbr
	rjmp	Dup
sbr:	nop
	clz
	clr	pir
	clr	pur
	rjmp	Dup
	
; .
;   
zader:	nop
	wdr
	clr	X
	clr	Y
	ldi	X,  $0A
dv:	nop
	wdr
	mov	Y,  par
dx:	dec	Y
	brne	dx
	dec	X
	brne	dv
	ret

;   
;     
TIME_0:	wdr	
	mov	r0, tempo
	mov	r1, tmp
	mov	r2, pir
	mov	r3, pur
	mov	r4, adr
	mov	par, r2	; 
	ldi	adr2, $37 ; 
	rcall	opros
	mov	par, r3	; 
	ldi	adr2, $3F ; 
	rcall	opros
	ldi	coc, $ff-45
	out	TCNT0, coc
	reti
;  
opros:	cli		;  
	nop
	mov 	r7, par	 ; par
	cpi	pir, $09 ;   
	brge	nasv	; ,   9
	ldi	ZH,	high(2*cod0)
	ldi	ZL,	Low(2*cod0)
	Add	ZL,	pir
ist:	brbc 2, hod
	ldi	tmp, $05
	add	ZL, tmp	; 
	dec	par	;par   
	rjmp	ist
	mov	par, r7	; par	
hod:	nop
	LPM	;   R0    Z
	and	adr, adr2 ;adr2- 
	clr	aur	; 
	out	PORTB, aur
	nop
	out	PORTB, adr
	nop
	nop
	nop
	out	PORTB, aur
	inc	pir
	rjmp	opros
nasv:	clr	pir
	clr	adr
	mov	tempo, r0
	mov	tmp, r1
	mov	pir, r2
	mov	pur, r3
	mov	adr, r4
	sei
	ret
;  
.org $100
cod0:
.DB  $3B, $3E, $3E, $3E, $3E, $3E, $3E, $3A
.DB  $3A

cod1:
.DB  $3B, $3A, $3E, $3E, $3A, $3A, $3A, $3A
.DB  $3A

cod2:
.DB  $3B, $3E, $3E, $3A, $3E, $3E, $3A, $3E
.DB  $3A

cod3:
.DB  $3B, $3E, $3E, $3E, $3E, $3A, $3A, $3E
.DB  $3A

cod4:
.DB  $3B, $3A, $3E, $3E, $3A, $3A, $3E, $3E
.DB  $3A

cod5:
.DB  $3B, $3E, $3A, $3E, $3E, $3A, $3E, $3E
.DB  $3A

cod6:
.DB  $3B, $3E, $3A, $3E, $3E, $3E, $3E, $3E
.DB  $3A

cod7:
.DB  $3B, $3E, $3E, $3E, $3A, $3A, $3A, $3A
.DB  $3A

cod8:
.DB  $3B, $3E, $3E, $3E, $3E, $3E, $3E, $3E
.DB  $3A

cod9:
.DB  $3B, $3E, $3E, $3E, $3E, $3A, $3E, $3E
.DB  $3A
.EXIT

 