.include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn15def.inc"

;   
;: -  ..

.DEF	X=r20	;
.DEF	Y=r21	;
.DEF	Ah=r18 ;
.DEF	Al=r17
.DEF	tmp=r16
.DEF	tmp2=r22
.DEF	tmp3=r23
.DEF	tmp4=r25
.DEF	par=r24
.DEF	Axx=r4
.DEF	Ayy=r5

;  
.cseg
.org 0
;   tiny15
	rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  PIN_CHANGE	  
	nop		;rjmp  TIME_1 COMPA	;   1
	nop		;rjmp  TIME_1	;   1
	nop		;RJMP  TIME_0 	;   0
	nop		;rjmp  EE_RDY ;  EEPROM
	nop		;rjmp  ANA_COMP	   
	rjmp  ADC
	
	
;    
.org 20

Reset:	nop
;    
	clr	tmp
	clr	tmp2
	clr	tmp3
	clr	tmp4
;     B
	ldi	tmp2, $10
	out	DDRB, tmp2
	clr	tmp2
	out	PORTB, tmp2
; ,  
nash:	nop
	ldi	par, $0F
	clr	tmp3
	ldi	tmp3, $81
	out	ADMUX, tmp3 	;   
	clr	tmp2
	clr	tmp3
	ldi	tmp2, $C8
	out	ADCSR, tmp2 	;   
	sleep 
; ,   25 
rw:	cli			; 
	clz			;  
	ldi	tmp2, $26
ru:	nop
	clz
	dec	tmp2
	nop
	brbc	1, ru
;  
	in	Axx, ADCL
	in	Ayy, ADCH
;	sei			; 
;    
	clr	tmp4
	clr	tmp
	clr tmp2
	ldi	tmp, $11 	;16 
	clr tmp3 
Start:	nop
	clz
	cp	tmp4, tmp 	;  16 . 
	breq	nash
;   
	inc 	tmp4
	ldi	tmp2, $3F
	nop
	clc
	cln			;  
;     
	mov	Al, Axx 
	mov	Ah, Ayy 
	sub	Al, Zl	
	sbc	Ah, Zh
	nop
	brbs	2, nash 	;   
	add	Zl, tmp2		;  
	adc	Zh, tmp3		;  
	rcall	zader
	out	PORTB, tmp4 	;  
	rjmp	Start
;    
ADC:	wdr
	mov r4, tmp
	clr tmp
	out	ADCSR, tmp
	mov tmp, r4
	reti
;  
SleepReset:
        ldi	r30,$3F		;     Power Down
        out	MCUCR,r30	;  
	sleep			; 
	rjmp	Reset		;   ,  

;  
zader:	nop
	wdr
	clr	X
	clr	Y
	ldi	X,  $0A
dv:	nop
	wdr
	mov	Y,  par
dx:	dec	Y
	brne	dx
	dec	X
	brne	dv
	ret

.EXIT
