.include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn15def.inc"

;      ..

;  
.DEF	tmp=r25
.DEF	tmp2=r26
.DEF	tmp3=r27
.DEF	tmp4=r28


;  
.cseg
.org 0
;   tiny15
	rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop		;rjmp  LOW_LEVEL ;  
	nop     ;rjmp  TIME_1	;   1
	rjmp  TIME_0 	;   0
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	
;    
.org 20

Reset:	nop
;    
	clr	tmp
	clr	tmp2
	clr	tmp3
	clr	tmp4
;     B
	ldi	tmp2,$07	   ;  4, 3
	out	DDRB,tmp2

;   0    
;     	
	ldi	tmp3,$02
	out	TIMSK,tmp3 ;     0

;  1   - 
;      1:1
;     
    ldi	tmp4,$69	;  #01101001
;   1    , 
;   ,
        out	TCCR1,tmp4	; 1   (1)       
;  
	ldi	tmp, $80
	out	SREG, tmp
;		sei

;    .
no:	nop
	clr	tmp4
;   2 
nan:	nop
	inc	tmp4
	clr	tmp
;  10 
	ldi	tmp,  $0A
	cp	tmp4, tmp
	brge	no	
;  
	ldi	tmp3, $01
	out	portB, tmp3
	rcall	ti0		;  0,16 
;  
	ldi	tmp3, $04
	out	portB, tmp3
	rcall	ti0		;  0,16 	
; ,   2  10 
; 
	clr	tmp
	out	PortB, tmp
re:	nop	
;   ,   
;   1    
	ldi	r31,High(2*SdTa)	;FreqIndex   
	ldi	r30,Low(2*SdTa)		; OCR1A  	
	lpm			;   r0 
	out	OCR1A,r0
	clr	tmp3
	out	PINB, tmp3
	ldi	tmp3,$9F	;  40 ,    1	
	out	OCR1B, tmp3 ; OCR1  
	nop
	ldi	tmp3,$02
	out	TIMSK,tmp3 ;      1
	rcall ti1
	ldi	tmp,  $14
	cp	tmp4, tmp
	brlo	re
	nop
	clr	tmp
	out	PINB, tmp
	rjmp	nan
;     
SleepReset:	nop
	clr	tmp
	out	portB, tmp
        ldi	r30,$3F		;     Power Down
        out	MCUCR,r30	;  
	sleep			; 
	rjmp	Reset		;   , 
; .
; 0,1632 
ti0:	nop
	clr	tmp
	ldi	tmp, $6A	;   0
	out	TCNT0, tmp
	clr	tmp
	clr tmp2
er:	nop
	inc	tmp2
	clr	tmp4
	ldi	tmp,$05
	out	TCCR0,tmp ; 0,   /1024
ve:	nop
	ldi	tmp,  $FA
	wdr
	cp	tmp, tmp4
	brge	retr
	rjmp	ve
	nop
retr:	nop
	cpi	tmp2,3
	brlt	er
	clr	tmp
	out	TCCR0,tmp	;  0
	ret
; 40  (25 )
ti1:	nop
	clr	tmp
	clr	tmp4
	ldi	tmp,$03
	out	TCCR0,tmp ; 0,   /64
vu:	nop
	ldi	tmp,  $FA
	wdr
	cp	tmp, tmp4
	brge	rer
	rjmp	vu
	nop
rer:	nop
	clr	tmp
	out	TCCR0,tmp	;  0
	ret
;     0	 
TIME_0:	nop
	clr	tmp4
	ldi	tmp4, $FA
	reti

;   .
.ORG	$100
SdTa:

.db $4A, $12    


.EXIT
