   .include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn26def.inc"
; -     ..
;      ATtiny26.

.def	start  	= r10
.def	kay  	= r11
.def	lef  	= r12
.def	for  	= r13	
.def	tmp  	= r16	
.def	tmp2  	= r17	
.def	tmp3  	= r18
.def	tempo	= r19
.def	speed	= r20
.def	pur	= r21
.def	par	= r22
.def	n	= r24
.def	x	= r25
.def	m	= r15
.def	adr	= r0
.def	step	= r23
.def	prg2	= r14


.cseg
.org 0
	rjmp	RESET
	rjmp  EXT_INT0	; IRQO
	nop		;rjmp  EXT_PIN	 PIN
	nop		;rjmp  TIME1_CMP1A    1
	nop		;rjmp  TIME1_CMP1B    1
	nop		;rjmp  TIME1_OVF0    1 
	nop		;rjmp  TIME0_OVF0    0 
	nop		;rjmp  USI_STRT   - 
	nop		;rjmp  USI_OVF   - 
	nop		;rjmp  EE_RDY   EEPROM 
	nop		;rjmp  ANA_COMP	   
	nop		;rjmp  ADC   	

.org 20
;  
RESET:	nop
	clr	tmp
	ldi	tmp, RAMEND	;   
	out	SP, tmp		;   
	nop
	clr	tmp
	out	DDRA, tmp
	out	PORTA, tmp	;  		
	out	DDRB, tmp
	out	PORTB, tmp	;  
	clr	tmp
	ldi	tmp, $F0	;PA4-PA7-		
	out	DDRA, tmp
	nop
	clr	tmp
	ldi	tmp, $09	;PB0,PB3 -		
	out	DDRB, tmp
	nop
;  
	ldi	tmp, $80
	out	SREG, tmp
;	sei
;  INT0
	ldi	tmp, $40	; INT0	
	out	GIMSK, tmp
	ldi	tmp, $00	; 
;Idle,       INT0 
	out	MCUCR, tmp		
	
;  
;   
	clr	tmp2
	clr	tmp3
	clr	pur
	clr	prg2
	clr	adr
	clr	start	
nStart:	nop		;  
	nop
	rcall	adcn	;  
	nop
	sei
	nop
ci:	nop		;  
	mov	tmp, start
	cpi	tmp, $AA ;    
	brne	ci
	nop
	nop
;  		
	rcall	STEP	; -
	nop
;  -
	push	tmp
	nop		;  
	mov	tmp, speed
	cpi	tmp, $99 ;  99  
	brne	spd
	nop
	pop	tmp
	nop
	rjmp	das
	nop	
spd:	nop
	rcall	zader	;  
	nop
das:	nop
	rcall	left	;?	
	nop
	rcall	opros	;  
	nop
	rcall	strob	;  
	nop
	rcall	for	;8 ?
	nop
	rjmp	nStart
;   
; 
adcn:	nop
	cli
	nop
	push	tmp
	clr	tmp
awe:	nop
	cpi 	tmp, $04
	brsh 	ass
	clr	tmp3
	ldi	tmp3, $C2	;  U,   3
; ADC2, ADLAR=0 -    
	out	ADMUX, tmp3 	;   
	clr	tmp2
	clr	tmp3
	ldi	tmp2, $C4	;, , 1/16
	out	ADCSR, tmp2 	;   
;  
	in	tmp2, ADCL
	in	tmp3, ADCH
	mov 	r2, tmp2
	mov 	r3, tmp3
	mov	r4, r2
	mov	r5, r3
	mov	r6, r4
	mov 	r7, r5
	inc	tmp
	rjmp 	awe

;  
ass:	nop
	clr 	r8
	clc
	add 	tmp2, r2
	adc 	r9, r8
	add 	tmp2, r4
	adc 	r9, r8
	add 	tmp2, r6
	adc 	r9, r8
	clc
	lsr	r9
	ror	tmp2
	lsr 	r9
	ror	tmp2
	clr	r9
	clc
	add 	tmp3, r3
	adc 	r9, r8
	add 	tmp3, r5
	adc 	r9, r8
	add 	tmp3, r7
	adc 	r9, r8
	clc
	lsr 	r9
	ror	tmp3
	lsr 	r9
	ror 	tmp3
	nop
	pop tmp
	ret
	
;   
zader:	nop
	wdr
	clr	M
	clr	pur
	ldi	pur, $78
	cpi	tmp3, $00
	brne 	goo
	ldi	tempo, $01
	add	tempo, tmp3
	nop
goo:	nop
	mov 	tempo, tmp3
dm:	nop
	cpi	tmp2, $00
	brne 	goq
	ldi	X, $01
	add	X,  tmp2
	nop
goq:	nop
	mov 	X, tmp2
dv:	nop
	wdr
	nop
dx:	dec	pur
	brpl	dx
	cln
	dec	X
	brpl	dv
	cln
	dec	tempo
	brne	dm
	ret

;    
opros:	nop
	cpi	par, $0B
	breq	prn2
	ldi	ZH,	high(2*prog1)
	ldi	ZL,	Low(2*prog1)
	Add	ZL,	par
	LPM
	mov	prg2, adr
	out	PORTB, prg2
	inc	par
	rjmp	got

prn2:	nop	
	clr	par
	clr	pur
	clr	adr
	clr	prg2
got:	nop
	ret

;  -
STEP:	nop
	pop	tmp
kay:	nop
	nop
	nop
	sbis	PORTA, 0	; ?
	rjmp	nakc
	nop
	inc		tmp
	nop
	sbis	PORTA, 0
	rjmp	nakc
	nop
	inc		tmp
	nop
	sbis	PORTA, 0
	rjmp	nakc
	nop
	inc		tmp
	nop	
	sbis	PORTA, 0
	rjmp	nakc
	nop
	inc		tmp
	nop
	sbis	PORTA, 0
	rjmp	nakc
	nop
	inc		tmp
	nop
	cpi		tmp, $04
	brlt	kay
	nop
	clr		pur
	ldi		pur,  $BE	; 	
	rcall	izmer
nakc:	nop
	sbic	PORTA, 0	; ?
	rjmp	kay
	nop
	sbic	PORTA, 0
	rjmp	kay
	nop
	sbic	PORTA, 0
	rjmp	kay
	nop	
	sbic	PORTA, 0
	rjmp	kay
	nop
	sbic	PORTA, 0
	rjmp	kay
	nop
	cpi		pur, $BE
	breq	der
	nop
	rjmp	uty
	nop
der:	nop		;  












	ldi	speed, $99
	nop
uty:	nop
	clr		pur
	push	tmp
	ret

;  , 
left:	nop
	nop
	clr	tempo
wer:	nop
	inc	tempo
	clz
	cpi	tempo, $04
	breq	right
	sbis	PORTA, 1
	rjmp	wer
	sbis	PORTA, 1
	rjmp	wer
	sbis	PORTA, 1
	rjmp	wer	
	sbis	PORTA, 1
	rjmp	wer
	sbis	PORTA, 1
	rjmp	wer
	nop
	push	tmp
	ldi	tmp, $DD	;
	mov	lef, tmp
	pop	tmp
	rjmp	fg
right:	nop
	push	tmp
	ldi	tmp, $44	;
	mov	lef, tmp
	pop	tmp
fg:	nop
	ret

;  8 ?
for:	nop
	push	tmp		; tmp
	mov	tmp, for	; for
	inc	tmp
	clz
	cpi	tmp, $08	; 8 ?
	breq	rav		; 8 .
	nop
	rjmp	nrav
rav:	nop
	clr	tmp
	mov	step, tmp	; R23
nrav:	nop
	mov	for, tmp
	pop	tmp		; tmp
	ret
;   
strob:	nop
	sbi	PORTB, 0		;  
	nop
	wdr
	nop
	clr	pur
	ldi	pur, $78
	nop
	cpi	tmp3, $00
	brne 	goo2
	ldi	tempo, $01
	add	tempo, tmp3
	nop
goo2:	nop
	mov 	tempo, tmp3
dm2:	nop
	cpi	tmp2, $00
	brne 	goq2
	ldi	X, $01
	add	X,  tmp2
	nop
goq2:	nop
	mov 	X, tmp2
dv2:	nop
	wdr
	nop
dx2:	dec	pur
	brpl	dx2
	cln
	dec	X
	brpl	dv2
	cln
	dec	tempo
	brne	dm2
	nop
	nop
	cbi	PORTB, 0		;  
	nop
	ret

;   
izmer:	nop
; 	
	push	m
	push	n
	push	x
	push	tmp3
;  3  0.m.n.x. 
	nop
	clr	x
	clr	m
	clr	n
	clr	tmp3
	clc

dm1:	nop
	clc
dv1:	nop
	wdr
	nop
	clc
dxx:	nop
	inc	x
	nop
	clc
dd:	nop
	inc	tmp3
	brbc	0, dd
	clr	tmp3
	brbc	0, dxx 
	clc
	nop
	clr	x
nak:	nop
	nop
	sbis	PORTB, 6
	rjmp	vak
	sbis	PORTB, 6
	rjmp	vak
	sbis	PORTB, 6
	rjmp	vak
vak:	nop	
	sbic	PORTB, 6
	rjmp	nak
	sbic	PORTB, 6
	rjmp	nak
	sbic	PORTB, 6
	rjmp	nak
	clc
	inc	n
	brbc	0, dv1
	clr	n
	clc
	adiw	r30, $01
	inc	m
	brbc	0, dm1
	; 
	pop	tmp3
	pop	m
	pop	n
	pop	x 
	;  
	cpi	r31, $D3
	brsh	hsd
	rjmp	rt
hsd:	nop
	cpi	r30, $45
	brlt	rt
rt:	nop	
	ret

;   -
EXT_INT0: nop
	push	tmp2		; tmp2
	in	tmp2, SREG	;  SREG
	cli
	nop	
	nop
;   
	push	speed
	mov	speed, start
	cpi	speed, $AA
	brne	fag
	ldi	speed, $AA	; 
	mov	start, speed
	nop
	rjmp	rt
fag:	nop
	ldi	speed, $22	; 
	mov	start, speed
	nop
	pop	speed
	out	SREG, tmp2	; SREG
	pop	tmp2		; tmp2
	nop
	sei
	reti

;    
.org $200
prog1:
.DB  $08, $0A, $02, $06, $04, $05, $01, $09

;    
.org $220
prog2:
.DB  $09, $01, $05, $04, $06, $02, $0A, $08


.EXIT

 