    .include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn12def.inc"
.def	tmp  	= 	r16	
.def	coc  	= 	r17	
.def	vih  	= 	r18
.def	tempo	= 	r19
.def	pir		=	r22
.def	pur		=	r23
.def	par		=	r20
.def	Y		=	r29
.def	X		=	r21
.def	W		=	r26
.def	adr		=	r0
.def	prg1	= 	r24
.def	prg2	=	r25



.cseg
.org 0
	nop		;rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop		;rjmp  TIME_OVF0   
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	

.org 20
;  
	clr	tmp		
	out	DDRB, tmp
	out	PORTB, tmp	;  
	clr	pir
	clr	pur
	clr	prg1
	clr	prg2
	clr	adr		

;   
;  
nStart:	nop			; 
	ldi	coc, $1E	;PB1,2,3,PB4-		
	out	DDRB, coc
	nop
	in	vih, PORTB
	cpi	vih, $01
	breq	nul
	ldi	tempo, $64
	rjmp	ser
nul:	ldi	tempo, $34
	nop
ser:	nop
	rcall	zader
	nop
	rcall	opros
	nop
	rjmp	nStart
	
;   


zader:	nop
	wdr
	clr	W
	clr	X
	clr	Y
	ldi	W,  $05
	ldi	X,  $F0
dm:	nop
dv:	nop
	wdr
	mov	Y,  tempo
dx:	dec	Y
	brne	dx
	dec	X
	brne	dv
	dec	W
	brne	dm
	ret

;   
opros:	nop
	cpi	pir, $14
	breq	prn2
	ldi	ZH,	high(2*prog1)
	ldi	ZL,	Low(2*prog1)
	Add	ZL,	pir
	LPM
	mov	prg1, adr
	out	PORTB, prg1
	inc	pir
	rjmp	got
prn2:	nop
	cpi	pur, $14
	breq	prn3
	ldi	ZH,	high(2*prog2)
	ldi	ZL,	Low(2*prog2)
	Add	ZL,	pur
	LPM
	mov	prg2, adr
	out	PORTB, prg2
	inc	pur
	rjmp	got
prn3:	nop
	cpi	par, $14
	breq	nasv
	ldi	ZH,	high(2*prog3)
	ldi	ZL,	Low(2*prog3)
	Add	ZL,	par
	LPM
	mov	prg2, adr
	out	PORTB, prg2
	inc	par
	rjmp	got
nasv:	clr	pir
	clr	pur
	clr	par
	clr	adr
got:	nop
	ret


.org $100
prog1:
.DB  $00, $02, $12, $18, $1A, $04, $10, $06
.DB  $08, $0A

prog2:
.DB  $0A, $08, $06, $10, $04, $1A, $18, $12
.DB  $02, $00

prog3:
.DB  $00, $04, $02, $10, $12, $06, $18, $08
.DB  $1A, $0A
.EXIT

 