.include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn15def.inc"

;    ..

;  
.DEF	tmp7=r20	
.DEF	tmp8=r21	
.DEF	Upor=r22 
.DEF	Unag=r23 
;  
.DEF	Axx=r18
.DEF	Ayy=r19
;  
.DEF	tmp5=r16
.DEF	tmp6=r17
.DEF	tmp=r25
.DEF	tmp2=r26
.DEF	tmp3=r27
.DEF	tmp4=r28
.DEF	tmp9=r24		
.DEF	tmp10=r29
.DEF	Totk=r11
.DEF	Tzak=r12
.DEF	Tnao=r13
.DEF	Tnaz=r14
.DEF	tmp11=r15

;  
.cseg
.org 0
;   tiny15
	rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop		;rjmp  LOW_LEVEL ;  
	nop	     	;rjmp  TIME_1	;   1
	rjmp  TIME_o 	;   0
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	
;    
.org 20

Reset:	nop
;    
	clr	tmp
	clr	tmp2
	clr	tmp3
	clr	tmp4
	ldi	tmp, Low(RAMEND)
	out	SPL, tmp
;     B
	ldi	tmp2,$07	   ;  4, 3 #00000111
	out	DDRB,tmp2

;   0    
;     	
	ldi	tmp3,$02
	out	TIMSK,tmp3 ;     0

;  1   - 
;      1:1
;    ,   40 
    ldi	tmp4,$69	;  #01101001
;   1    , 
;   ,
    out	TCCR1, tmp4	; 1   (1)       
;  

;	sei

; .
no:	nop
	clr	tmp4
	clr	r10
	clr	tmp
;***********************************************
;   
	nop
	mov tmp9, r9
	subi tmp9, $69	;   
	nop
	brbs 2, gg 	;   
	rjmp RNE		;  , 
gg:	clr	tmp
	nop
; 
	ldi	Axx, $00		;   
	ldi	Ayy, $08		;   
	ldi	tmp6, $03	;   
tyr:	nop
	dec	tmp6
	brbs	2, RNE 		; 
	rcall	ADC1		;  
	cpi	tmp5, $56
	nop
	breq error		; 
	nop
	rcall SF
	rjmp	tyr
RNE:	nop
	clr	tmp
	ldi	tmp9, $69		;  
	mov	r9, tmp9
	rjmp	SET
	nop
;***********************************************
;   
Stab:	nop
	rcall	ADC1		; 
	nop
SET:	nop
	rcall	ADC2		; 
	nop
	rcall	SF
	rjmp Stab
; 
SF: 	nop 
	nop;    ,   
;*****************************************************
;1	
	ldi	tmp4, $69	;  #01101001
;   1    , 
;   ,  , CK/8
        out	TCCR1, tmp4	; 1   (1) 
	mov 	tmp3, r4
	out	OCR1B, tmp3	 ; OCR1  
	ldi	tmp9, $02
	out	TIMSK, tmp9   ;      1
	ret
;***********************************************

;   
error:	nop
	
;    

;  
;  
	in	Upor, portB
	ldi	Unag, $04
	or	Unag, Upor
	out	portB, Unag
	rcall	ti0		;  0,16 	
	rcall	ADC1		; 
	cpi	r16, $56
	breq	error
	rcall	ADC2		; 
	cpi	r16, $76
	breq	error
; 
;  	
;  
	in	tmp4, portB
	clr	Unag
	ldi	Unag, $01
	or	Unag, tmp4
	out	portB, tmp3
	rjmp	Stab		; 

;***********************************************
;      
;  1    
ADC1:	nop
;    
	clr	tmp10
	clr	tmp
	clr	tmp5
	mov	r8, tmp6
	clr tmp6
	cli			;  	
; 1,  
	ldi	tmp10, $83	;#10000011
;   ,  4
	out	ADMUX, tmp10 	;  
	ldi	tmp, $C8	;#11000010
; 1, ,  , =4
	out	ADCSR, tmp 	;    
;  1
	in	tmp5, ADCL
	in	tmp6, ADCH
	mov	r12, tmp5
	mov	r11, tmp6
;	sei			; 

;    
;  3	
	clc			;  
	cln			;  
;     
	mov	Zl, r11 
	mov	Zh, r12
	subi	Zl, $01	;   3 
	sbci	Zh, $E0	;   3   
	brbs	2, goo1 ;,   
;  2,8 	
	clc			;  
	cln			;  
;     
	mov	Zl, r11 
	mov	Zh, r12
	subi	Zl, $01	;   2,8 
	sbci	Zh, $C0	;   2,8   
	brbs	2, goo2 ;,    
;  2,5 	
	clc			;  
	cln			;  
;     
	mov	Zl, r11 
	mov	Zh, r12
	subi	Zl, $01	;   2,5 
	sbci	Zh, $90	;   2,5   
	brbs	2, goo3 ;,   
;  2 	
	clc			;  
	cln			;  
;     
	mov	Zl, r11
	mov	Zh, r12
	subi	Zl, $01	;   2 
	sbci	Zh, $40	;   2   
	brbs	2, goo4 ;,   
;  1,8 	
	clc			;  
	cln			;  
;     
	mov	Zl, r11 
	mov	Zh, r12
	subi	Zl, $01	;   1,8 
	sbci	Zh, $20	;   1,8   
	brbs	2, goo5 ;,   
	ldi	r16, $56	;  
	
;   
goo1:	nop
	ldi	zl, Low(S3<<1)
	ldi	zh, High(S3<<1)
	add	r30, Ayy
	adc	r31, Axx
	lpm
	mov	r4, r0
	rjmp	RNVV
goo2:	nop
	ldi	zl, Low(S28<<1)
	ldi	zh, High(S28<<1)
	add	r30, Ayy
	adc	r31, Axx
	lpm
	mov	r4, r0
	rjmp	RNVV
goo3:	nop
	ldi	zl, Low(S25<<1)
	ldi	zh, High(S25<<1)
	add	r30, Ayy
	adc	r31, Axx
	lpm
	mov	r4, r0
	rjmp	RNVV
goo4:	nop
	ldi	zl, Low(S2<<1)
	ldi	zh, High(S2<<1)
	add	r30, Ayy
	adc	r31, Axx
	lpm
	mov	r4, r0
	rjmp	RNVV
goo5:	nop
	ldi	zl, Low(S18<<1)
	ldi	zh, High(S18<<1)
	add	r30, Ayy
	adc	r31, Axx
	lpm
	mov	r4, r0
RNVV: nop
	mov	tmp6, r8
	ret
;***********************************************
;  2    
ADC2:	nop
	;    
	clr	tmp10
	clr	tmp
	cli			;  	
; 2,  
	ldi	tmp10, $83	;#10000000
;   ,  5
	out	ADMUX, tmp10 	;   
	ldi	tmp, $C8	;#11000010
; 2, ,  , =4
	out	ADCSR, tmp 	;    
;  2
	in	Axx, ADCL
	in	Ayy, ADCH
	mov	r13, Axx
	mov	r14, Ayy
;	sei			; 

;    
;  5,9 	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi Zl, $03	;   5,9 
	sbci Zh, $B0	;   5,9   
	brpl ewe
	rjmp gaa 	;   
;  5,7 
ewe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   5,7 
	sbci	Zh, $90	;   5,7   
	brpl zwe
	rjmp gbb 	;   
;  5,5 
zwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   5,5 
	sbci	Zh, $70	;   5,5   
	brpl xwe
	rjmp gcc 	;   
;  5,4 
xwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   5,4 
	sbci	Zh, $60	;   5,4   
	brpl cwe
	rjmp gdd 	;  
;  5,3 
cwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   5,3 
	sbci	Zh, $50	;   5,3   
	brpl vwe
	rjmp gee 	;  
;  5,2 
vwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   5,2 
	sbci	Zh, $40	;   5,2   
	brpl bwe
	rjmp gff 	;   
;  5,1 
bwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   5,1 
	sbci	Zh, $30	;   5,1   
	brpl nwe
	rjmp gjj 	;  
;  5 
nwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   5 
	sbci	Zh, $20	;   5   
	brpl mwe
	rjmp ghh 	;   
;  4,9 
mwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   4,9 
	sbci	Zh, $10	;   4,9   
	brpl lwe
	rjmp gii 	;  
;  4,8 
lwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $03	;   4,8 
	sbci	Zh, $00	;   4,8   
	brpl kwe
	rjmp ggg 	;  
;  4,7 	
kwe:	nop
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $02	;   4,7 
	sbci	Zh, $F0	;   4,7   
	nop
	brpl hwe
	rjmp gkk 	;   
;  4,6 	
hwe:	nop
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $02	;   4,6 
	sbci	Zh, $E0	;   4,6   
	brpl fwe
	rjmp gll 	;  
;  4,5 
fwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $02	;   4,5 
	sbci	Zh, $D0	;   4,5   
	brpl dwe
	rjmp gmm 	;   
	nop
;  4,4 
dwe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $02	;   4,4 
	sbci	Zh, $D0	;   4,4   
	brpl awe
	rjmp gnn 	;   
;  4,3 
awe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $02	;   4,3 
	sbci	Zh, $B0	;   4,3   
	brpl twe
	rjmp goo 	;  
;  4,2 
twe:	nop	
	clc			;  
	cln			;  
;     
	mov	Zl, r13 
	mov	Zh, r14
	subi	Zl, $02	;   4,2 
	sbci	Zh, $A0	;   4,2   
	brpl uwe
	rjmp gpp 	;  
;  4,1 
uwe:	nop	
	
	ldi	tmp5, $56;  
	rjmp	RNWW	
gaa:	nop
	ldi	Axx, $00
	ldi	Ayy, $10
	rjmp	RNWW
gbb:	nop
	ldi	Axx, $00
	ldi	Ayy, $0F
	rjmp	RNWW
gcc:	nop
	ldi	Axx, $00
	ldi	Ayy, $0E
	rjmp	RNWW
gdd:	nop
	ldi	Axx, $00
	ldi	Ayy, $0D
	rjmp	RNWW
gee:	nop
	ldi	Axx, $00
	ldi	Ayy, $0C
	rjmp	RNWW
gff:	nop
	ldi	Axx, $00
	ldi	Ayy, $0B
	rjmp	RNWW
gjj:	nop
	ldi	Axx, $00
	ldi	Ayy, $0A
	rjmp	RNWW
ghh:	nop
	ldi	Axx, $00
	ldi	Ayy, $09
	rjmp	RNWW
gii:	nop
	ldi	Axx, $00
	ldi	Ayy, $08
	rjmp	RNWW
ggg:	nop
	ldi	Axx, $00
	ldi	Ayy, $07
	rjmp	RNWW
gkk:	nop
	ldi	Axx, $00
	ldi	Ayy, $06
	rjmp	RNWW
gll:	nop
	ldi	Axx, $00
	ldi	Ayy, $05
	rjmp	RNWW
gmm:	nop
	ldi	Axx, $00
	ldi	Ayy, $04
	rjmp	RNWW
gnn:	nop
	ldi	Axx, $00
	ldi	Ayy, $03
	rjmp	RNWW
goo:	nop
	ldi	Axx, $00
	ldi	Ayy, $02
	rjmp	RNWW
gpp:	nop
	ldi	Axx, $00
	ldi	Ayy, $01
	nop
RNWW:	nop
	ret
;***********************************************
;  .
; 0,1632 
ti0:	nop
	clr	tmp
	ldi	tmp, $6A		;   0
	out	TCNT0, tmp
	clr	tmp
	clr tmp10
er:	nop
	inc	tmp10
	clr	tmp4
	ldi	tmp, $05
	out	TCCR0, tmp 	; 0,   /1024
ve:	nop
	ldi	tmp,  $FA
	wdr
	cp	tmp, Unag
	brge	retr
	rjmp	ve
	nop
retr:	nop
	cpi	tmp10, $03
	brlt	er
	clr	tmp
	out	TCCR0, tmp	;  0
	ret
;***********************************************

;     0	 
TIME_o:	nop
	clr	Unag
	ldi	Unag, $FA
	reti

;***********************************************

;   1
.ORG	$1CA
S18:
.db $31, $32, $34, $35, $36, $37, $38, $39  ; 
.db $3A, $3C, $3D, $3E, $40, $43, $44, $46  ; 

S2:
.db $36, $38, $3A, $3B, $3C, $3D, $3E, $40  ; 
.db $41, $42, $44, $45, $47, $4A, $4C, $4E  ; 

S25:
.db $43, $46, $48, $4A, $4B, $4C, $4E, $50  ; 
.db $51, $53, $55, $56, $58, $5C, $5F, $61  ; 

S28:
.db $4B, $4E, $51, $52, $54, $56, $57, $59  ; 
.db $5B, $5D, $5F, $61, $63, $68, $6A, $6D  ; 

S3:
.db $51, $54, $57, $58, $5A, $5C, $5E, $5F  ; 
.db $61, $63, $65, $68, $6A, $6F, $72, $74  ; 


.EXIT
