    .include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn15def.inc"
;:  ..
;: 30.06.2007
;: 1.3.6
; : Test_25_6.asm
;: AVR tiny15.
; : 1.6
;:  4,5 
.DEVICE ATtiny15
.list

.def	tmp   = r25	;  
.def	tmp1  = r16	;  
.def	time  = r17	;   
.def	dbyt  = r18	;       I2C
.def	Flg   = r19	;  
.def	Dig43 = r20	;  4  3  
.def	Dig21 = r21	;  2  1  
.def	tt = r22	;  
.def	tt1 = r23	;  
.def	tt2 = r24	;  

;    Flg:
.equ	Ack   = 0	;   =  0


; / I2C:
.equ  SDA     = PB1	; SDA =  B /  1
.equ  SCL     = PB2	; SCL =  B /  2
.equ  ERR     = PB0	; ERR =  B /  0
;    I2C:
.equ  DispAdr = $76	;   SAA1064 ( ADR (1) - Vcc)
.equ  DisrAdr = $77	;   SAA1064 ( ADR (1) - Vcc)

	
.cseg
.org 0
	rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop		;rjmp  TIME_OVF0   
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	
.org 10
;   
;  
RESET:	nop
	clr	tmp		;  	
	out	DDRB, tmp
	out	PORTB, tmp	;  
	clr	tmp
	ldi	tmp, $07	;0,PB1,2-		
	out	DDRB, tmp
	
;  
Initial: nop
	ldi   dbyt,Low(RAMEND)	;   
	out   SPL,dbyt		;   	
	ldi   Flg,$01		;   0  ,  Ack
	clr	  tt		;  
	ldi	tmp, $01
	out	PORTB, tmp	;    
	ldi	dig21, $11	;    
	ldi	dig43, $25	;    25
	mov   tt1,Dig21	;  1 ()  2 ()
	swap  tt1		;      
	andi  tt1,$0F		;    ( 1)
	mov   tt2,Dig43	;  3 () 
	swap  tt2		;      
	andi  tt2,$0F		;    ( 3)
	nop
;      	
read:	ldi	dbyt, DisrAdr	;  
	rcall Start
RB1:	nop	
	sbi	DDRB, SCL	;  SCL
	rcall wait5us		;  
	cbi	DDRB, SCL	;  SCL
RB2:	nop
	sbis	PinB, SCL	;   	
	rjmp	RB2
	rcall wait5us		;  
	clc			;  
	sbic	PinB, SDA	; SDA=1
	sec			;  
	rol	dbyt		;    
	brcc	RB1		;    
SetAck:	nop			;  
	sbi	DDRB, SCL	;  SCL
	sbrs	Flg, Ack	;  ,  Ack=1
	rjmp	SA1		;  =0
	cbi	DDRB, SDA	; SDA  1
	rjmp	SA2
SA1:	nop
	sbi	DDRB, SDA	; SDA  0
SA2:	nop
	rcall wait5us		;  
	cbi	DDRB, SCL	;  SCL
SA3:	nop
	sbis	PinB, SCL	;   
	rjmp	SA3
	rcall wait5us		;  
	rcall stopp		;   
	
Haupt:  nop
;  SAA1064
;     SAA1064
	ldi   dbyt,DispAdr	;  SAA1064,  - 
;    +  			
	rcall Start		;    +  
	sbrc  Flg,Ack		;   ,  
	rjmp	ss		; ,   
	ldi   dbyt,$00		;    
	rcall WriteByte		;   
	sbrc  Flg,Ack		;   ,  
	rjmp	ss		; ,   
	ldi   dbyt,$47		; .,  ,  
	rcall WriteByte		;   	
; 
ss:	nop
	rcall stopp		;   
	sbrc  Flg,Ack		;   ,   
	rjmp  Haupt		;  ,   
;  4-   SAA1064
	ldi   dbyt,DispAdr	;  SAA1064,  - 
	rcall Start		;    +  
	sbrc  Flg,Ack		;   ,  
	rjmp  erro		; ,   
	ldi   dbyt,$01		;  = Digit 1
	rcall WriteByte		;   
	sbrc  Flg,Ack		;   ,  
	rjmp  erro		; ,   
	mov   tmp1,Dig21	;  1 ()  2 ()
	andi  tmp1,$0F		;    ( 2)
	rcall Get7Segm		;  7-   
	rcall WriteByte		;   1
et:	rcall	Stopp
	ldi   dbyt,DispAdr	;  SAA1064,  - 
	rcall Start		;    +  
	sbrc  Flg,Ack		;   ,  
	rjmp  erro		; ,   
	ldi   dbyt,$02		;  = Digit 1
	rcall WriteByte		;   
	sbrc  Flg,Ack		;   ,  
	rjmp  et		; 
	mov	tmp1, tt2
	rcall Get7Segm		;  7-   
	rcall WriteByte		;   2
ot:	rcall	Stopp
	ldi   dbyt,DispAdr	;  SAA1064,  - 
	rcall Start		;    +  
	sbrc  Flg,Ack		;   ,  
	rjmp  erro		; ,   
	ldi   dbyt,$03		;  = Digit 1
	rcall WriteByte		;   
	sbrc  Flg,Ack		;   ,  
	rjmp  ot		;  
	mov   tmp1,Dig43	;  3 ()  4 ()
	andi  tmp1,$0F		;    ( 4)
	rcall Get7Segm		;  7-   
	rcall WriteByte		;   3
rt:	rcall	Stopp
	ldi   dbyt,DispAdr	;  SAA1064,  - 
	rcall Start		;    +  
	sbrc  Flg,Ack		;   ,  
	rjmp  erro		; ,   
	ldi   dbyt,$04		;  = Digit 1
	rcall WriteByte		;   
	sbrc  Flg,Ack		;   ,  
	rjmp  rt		;  
	mov	tmp1, tt1
	rcall Get7Segm		;  7-   
	rcall WriteByte		;   4
	rcall	Stopp
	rjmp Initial		;    

erro: nop			;  
	inc	tt		;  1
	cpi	tt, 4		;  
	brne	vb		;    
	clr	tmp
	out	PORTB, tmp	;   
	rcall stopp		;   
	nop
	rcall w200
	clr	tt		; 
vb:	nop
	rjmp initial		;   

Start: nop
	clz				
	sbi	DDRB,SDA	; SDA = . 0:  
	rcall wait4us	;  
WriteByte: nop			;     
	clz	
	sec			;   C = 1
	rol   dbyt		;  , C->LSB, MSB->C
	rjmp  bit1		;    1
WriteBit: nop
	lsl   dbyt		;  dbyt , ...
bit1:	nop
	breq  GetAck		; ...   
	sbi	DDRB,SCL	; SCL = . 0   SCL
	brcc  WriteLow		; ,   C = 0
	nop			;    
	cbi	DDRB,SDA	; SDA -   SDA  1
	rjmp  SCL_High
WriteLow: nop
	sbi	DDRB,SDA	; SDA = . 0  SDA  0
	nop	;    
SCL_High: nop
	rcall wait4us		;  
	cbi	DDRB,SCL	; SCL -    SCL
WB1:	nop
	sbis  PinB,SCL		;     ?
	rjmp  WB1
	rcall wait5us		;  
	rjmp	WriteBit
GetAck:	nop			;     
	sbi	DDRB,SCL	; SCL = . 0   SCL
	cbi	DDRB,SDA	; SDA -  SDA   
	rcall wait5us		;  
	cbi	DDRB,SCL	; SCL -    SCL
GA1:    nop
	sbis  PinB,SCL		;     
	rjmp  GA1
	cbr   Flg,1<<Ack	;  Ack = 0
	sbic  PinB,SDA		;  SDA = 1,
	sbr   Flg,1<<Ack	;    Ack = 1
	rcall wait4us		;  
	ret
;    7- . 
Get7Segm: nop
	ldi	ZH,	high(2*prog3)
	ldi	ZL,	Low(2*prog3)
	Add	ZL,	tmp1
	lpm
	mov	dbyt, r0  
	ret
;   STOP
Stopp:	nop			;   
	sbi	DDRB,SCL	; SCL = . 0   SCL
	sbi	DDRB,SDA	; SDA = . 0		;  SDA  0
	rcall wait5us		;  
	cbi	DDRB,SCL	; SCL -   SCL  1
	rcall wait5us		;  
	cbi	DDRB,SDA	; SDA -    SCL
	rcall wait5us		;  
	ret

;  12 
Wait5us:nop			;   12   f = 1,6 
	ldi   time,2
W5:	nop
	dec   time		; 4 x 2  + rcall + ret
	brne  W5		;   	
	ret
;  6 
Wait4us:			;   6   f = 1,6 
	ldi   time,1
W4:	nop
	dec   time		; 3 x 1  + rcall + ret
	brne  W4
	nop		;   
	ret
W200: nop
; 200 
	ldi	tt,	0	; 
	ldi	tt1, 0x35	; 
	
	clc			;  
nn:	subi tt, 1		; 1  
	subi tt1, 0		;  
	
	brcc nn			;    
	ret
;  7- 
.ORG	$1F0
prog3:	
.DB   $3F,$06,$5B,$4F,$66,$6D,$7D,$07	;  0..7
.DB   $7F,$6F,$77,$7C,$39,$5E,$00,$40	;  8..D,E=,F=
.DB   $7F,$6F,$77,$7C,$39,$5E,$79,$71	;  8..F





 